                                                                              
#
# Example of using main in a Python program.
# 
# If run from the command line, execution begins with the code that
# is not within any function.  Because that code doesn't invoke any of
# the functions, they don't run.
#
# Functions in this file can be invoked directly from other Python files
# but the code that is outside the functions will run when the file is imorted.
#

def foo():
    print()
    print('Welcome to the foo function.')
    print('Copyright Dave Grohl.')
    print()
    

def main():
    print()
    print('This is the main function.')
    print('In Python, main() is not special.')
    print('This makes main() very sad.')
    
    foo()
    
    print('foo() has returned and we are back in main')
    print()

    
print()
print('This is not in __main__.')
print('It runs when we execute this file or')
print('when we import this file.')
print('This behavior may or may not be what we want.')
main()
print()

