
#
# Example of using main in a Python program.
# 
# If run from the command line, execution begins at __main__.
# Functions in this file can be invoked directly from other Python files.
#

def foo():
    print()
    print('Welcome to the foo function.')
    print()
    

def main():
    print()
    print('This is the main function.')
    print('In Python, main() is not special.')
    print('This makes main() very sad.')
    
    foo()
    
    print('foo() has returned and we are back in main')
    print()

    
if __name__ == '__main__':
    print()
    print('This is __main__.')
    print('It is special in Python.')
    print('It is where execution begins.')
    
    main()

    print('main() has returned and we are back in __main__')
    print()
    